# Architecture

This document give a quick overview of each directory's functionality and some implementation details.

## Schemas

We use MongoDB as a database. *ALL* document model schemas is stored in `schema/`.
It's set-up in `app.module.ts`.

## App Initialization

1. Entrypoint in `main.ts`
    - Setup swagger-ui
    - Setup CORS
2. Starting app in `app.module.ts`
    - Load env to config
       - `google-secret.ts`: fill secret config from Google Secret using rules in `GOOGLESECRET` env.
    - Connect to MongoDB
    - Setup global input validation
    - Load all the API module

## Authentiation

Authentication is handled in `auth/`. It first authenticate the user using ChulaSSO, 
then setup the following scheme:

1. Authenticate with ChulaSSO
    1. Validate the SSO's token
    2. Create new refresh token for the user (in DB) and also store it in http-only cookie
2. Get access token from `POST /api/auth/refresh_token`

TODO: How do endpoints validate user?

## Proposal-Topic-Voice Concept

### Proposal

**Proposal** is a collection of *voices* which has a common goal. 
It may contains name and description. Only admin may create a *proposal*.

It is managed by `proposal/` which handle

- Listing of all proposal
- Details of the proposal and popular voices

### Voice

**Voice** is a post created by the user. Each voice is associated with exactly one *proposal*.
A voice may have list of *topics* which are freely specified by the user.

It's managed by `voice/` which handles

- Statistic Operation
    - Counting number of voices in the proposal or in all proposals
- Listing operation with a filter
    - Listing of voices in the proposal with pagination
    - Listing of voices by topics with pagination
    - Listing of voices created by a specific user
- Moderator operation
    - Listing of voices that got reported
    - Listing of quaratined voices
    - Quaratining voices
- CRUD operation on a voice
    - Showing voice by its id
    - Creation and deletion of voices
    - Listing of replies in the voice (note that the replies are truncated when using other endpoints)
- User-Voice interaction
    - Reporting voice
    - Upvote
    - Reply

#### Optimized voices schema

To optimise the indexing performance, The voice is not a subdocument or an array in proposal document but instead, each proposal has its own *collection* to store the voices.

#### Voice quaranteen quirk

Normally, quaranteeing post is done by setting a flag on the post. Here, we delete and move the voice to separate quarantee collection which is a pararell of the schema above.

### Topic

**Topic** is a tag that user can freely implictly create by adding it to a voice.

It may be listed for a specified proposal by `/proposal`

## Wordcloud

**Wordcloud** is a service that generate a picture of a wordcloud of popular voices in the specified topic.
It's generated by first generating an HTML file then capturing the rendered result using Pupeteer.